## debian-cd 3.0.4

=== Makefile ===
#!/usr/bin/make -f

# Main Makefile for debian-cd
#
# Copyright 1999 Rapha?l Hertzog <hertzog@debian.org>
# See the README file for the license
#
# Significantly modified 2005-2006 Steve McIntyre <93sam@debian.org>
# for multi-arch and mixed bin/src discs
#
# The environment variables must have been set
# before. For this you can source the CONF.sh 
# file in your shell


## DEFAULT VALUES
ifndef VERBOSE_MAKE
Q=@
endif
ifndef TASK
TASK=$(BASEDIR)/tasks/Debian_$(CODENAME)
endif
ifndef MKISOFS
export MKISOFS=$(shell which genisoimage mkisofs | head -1)
endif
ifndef MKISOFS_OPTS
#For normal users
MKISOFS_OPTS=-r
#For symlink farmers
#MKISOFS_OPTS=-r -F .
endif
ifndef HOOK
HOOK=$(BASEDIR)/tools/$(CODENAME).hook
endif
ifndef DOJIGDO
export DOJIGDO=0
endif

export BUILD_DATE=$(shell date -u +%Y%m%d-%H:%M)
export ARCHES_NOSRC=$(shell echo $(ARCHES) | sed 's/source//')
ifeq ($(ARCHES),source)
	export SOURCEONLY=yes
endif
ifeq ($(shell echo $(ARCHES) | sed 's/.*source.*/1/'),1)
	export INC_SOURCE=yes
endif

## Internal variables  
apt=$(BASEDIR)/tools/apt-selection
list2cds=$(BASEDIR)/tools/list2cds
md5sum=md5sum
jigdo_cleanup=$(BASEDIR)/tools/jigdo_cleanup
grab_md5=$(BASEDIR)/tools/grab_md5
make_image=$(BASEDIR)/tools/make_image
merge_package_lists=$(BASEDIR)/tools/merge_package_lists
update_popcon=$(BASEDIR)/tools/update_popcon
update_tasks=$(BASEDIR)/tools/update_tasks
grab_source_list=$(BASEDIR)/tools/grab_source_list

BDIR=$(TDIR)/$(CODENAME)
ADIR=$(APTTMP)
DB_DIR=$(BDIR)/debootstrap

export DEBOOTSTRAP_DIR := $(DB_DIR)/usr/lib/debootstrap
export PATH := $(DB_DIR)/usr/sbin:$(PATH)

LATEST_DB := $(shell ls -1tr $(MIRROR)/pool/main/d/debootstrap/debootstrap*all.deb | tail -1)

## DEBUG STUFF ##

default:
	@echo "Please refer to the README file for more information"
	@echo "about the different targets available."

## CHECKS ##

# Basic checks in order to avoid problems
ok:
ifndef TDIR
	@echo TDIR undefined -- set up CONF.sh; false
endif
ifndef BASEDIR
	@echo BASEDIR undefined -- set up CONF.sh; false
endif
ifndef MIRROR
	@echo MIRROR undefined -- set up CONF.sh; false
endif
ifndef ARCHES
	@echo ARCHES undefined -- set up CONF.sh; false
endif
ifndef CODENAME
	@echo CODENAME undefined -- set up CONF.sh; false
endif
ifndef OUT
	@echo OUT undefined -- set up CONF.sh; false
endif
ifdef NONFREE
ifdef EXTRANONFREE
	@echo Never use NONFREE and EXTRANONFREE at the same time; false
endif
endif
	@if [ $(DISKTYPE) = "NETINST" -o $(DISKTYPE) = "BC" ] ; then \
		if [ "$(INC_SOURCE)"x = "yes"x ] ; then \
			echo "Including source is not supported on a netinst/bc CD"; \
			false; \
		fi; \
	fi

## INITIALIZATION ##

# Creation of the directories needed
init: ok $(OUT) $(TDIR) $(BDIR) $(ADIR) $(BDIR)/DATE $(DB_DIR) unstable-map
$(OUT):
	$(Q)mkdir -p $(OUT)
$(TDIR):
	$(Q)mkdir -p $(TDIR)
$(BDIR):
	$(Q)mkdir -p $(BDIR)
$(ADIR):
	$(Q)mkdir -p $(ADIR)
$(BDIR)/DATE:
	$(Q)date '+%Y%m%d' > $(BDIR)/DATE
$(DB_DIR): $(LATEST_DB)
	@rm -rf $(DB_DIR)
	@dpkg -x $(LATEST_DB) $(DB_DIR)
	if [ ! -e $(DEBOOTSTRAP_DIR) ] ; then \
		ln -sf share $(DB_DIR)/usr/lib ; \
	fi

# Make sure unstable/sid points to testing/lenny, as there is no build
# rule for unstable/sid.
unstable-map:
	$(Q)if [ ! -d $(BASEDIR)/data/sid ] ; then \
		ln -s lenny $(BASEDIR)/data/sid ; \
	fi
	$(Q)if [ ! -d $(BASEDIR)/tools/boot/sid ] ; then \
		ln -s lenny $(BASEDIR)/tools/boot/sid ; \
	fi

#################
## CLEAN RULES ##
#################

# Cleans the current arch tree (but not packages selection info)
clean: ok dir-clean
dir-clean:
	$(Q)rm -rf $(BDIR)/CD[1234567890]*
	$(Q)rm -f $(BDIR)/*.filelist*
	$(Q)rm -f  $(BDIR)/packages-stamp $(BDIR)/upgrade-stamp $(BDIR)/md5-check

# Completely cleans the current arch tree
realclean: distclean
distclean: ok clean
	$(Q)echo "Cleaning the build directory"
	$(Q)rm -rf $(ADIR)
	$(Q)rm -rf $(TDIR)

####################
## STATUS and APT ##
####################

$(CODENAME)_status: ok init
	$(Q)for ARCH in $(ARCHES_NOSRC); do \
		echo "Using the provided status file for $(CODENAME)-$$ARCH ..."; \
		cp $(BASEDIR)/data/$(CODENAME)/status.$$ARCH $(ADIR)/$(CODENAME)-$$ARCH/status 2>/dev/null || $(MAKE) status || $(MAKE) correctstatus ; \
	done

# Regenerate the status file with only packages that
# are of priority standard or higher
status: init $(ADIR)/status
$(ADIR)/status:
	@echo "Generating a fake status file for apt-get and apt-cache..."
	$(Q)for ARCH in $(ARCHES); do \
		mkdir -p $(ADIR)/$(CODENAME)-$$ARCH; \
		if [ $$ARCH = "source" -o "$(INSTALLER_CD)" = "1" -o "$(INSTALLER_CD)" = "2" ];then \
			:> $(ADIR)/$(CODENAME)-$$ARCH/status ; \
		else \
			zcat $(MIRROR)/dists/$(CODENAME)/main/binary-$$ARCH/Packages.gz | \
			perl -000 -ne 's/^(Package: .*)$$/$$1\nStatus: install ok installed/m; print if (/^Priority: (required|important|standard)/m or /^Section: base/m);' \
			>> $(ADIR)/$(CODENAME)-$$ARCH/status ; \
		fi; \
	done;
	:> $(ADIR)/status
    # Updating the apt database
	$(Q)for ARCH in $(ARCHES); do \
		export ARCH=$$ARCH; \
		$(apt) update; \
	done
    #
    # Checking the consistency of the standard system
    # If this does fail, then launch make correctstatus
    #
	$(Q)for ARCH in $(ARCHES); do \
		export ARCH=$$ARCH; \
		$(apt) check || $(MAKE) correctstatus; \
	done

# Only useful if the standard system is broken
# It tries to build a better status file with apt-get -f install
correctstatus: status apt-update
    # You may need to launch correctstatus more than one time
    # in order to correct all dependencies
    #
    # Removing packages from the system :
	$(Q)set -e; \
	if [ "$(ARCHES)" != "source" ] ; then \
		for ARCH in $(ARCHES_NOSRC); do \
			export ARCH=$$ARCH; \
			for i in `$(apt) deselected -f install`; do \
				echo $$ARCH:$$i; \
				perl -i -000 -ne "print unless /^Package: \Q$$i\E/m" \
				$(ADIR)/$(CODENAME)-$$ARCH/status; \
			done; \
		done; \
    fi
    #
    # Adding packages to the system :
	$(Q)set -e; \
	if [ "$(ARCHES)" != "source" ] ; then \
		for ARCH in $(ARCHES_NOSRC); do \
			export ARCH=$$ARCH; \
			for i in `$(apt) selected -f install`; do \
				echo $$ARCH:$$i; \
				$(apt) cache dumpavail | perl -000 -ne \
				"s/^(Package: .*)\$$/\$$1\nStatus: install ok installed/m; \
				print if /^Package: \Q$$i\E\s*\$$/m;" \
				>> $(ADIR)/$(CODENAME)-$$ARCH/status; \
			done; \
		done; \
    fi
    #
    # Showing the output of apt-get check :
	$(Q)for ARCH in $(ARCHES_NOSRC); do \
		ARCH=$$ARCH $(apt) check; \
	done

apt-update: status
	$(Q)if [ "$(ARCHES)" != "source" ] ; then \
		for ARCH in $(ARCHES); do \
			echo "Apt-get is updating its files ..."; \
			ARCH=$$ARCH $(apt) update; \
		done; \
    fi

## GENERATING LISTS ##

# Deleting the list only
deletelist: ok
	$(Q)-rm $(BDIR)/rawlist
	$(Q)-rm $(BDIR)/rawlist-exclude
	$(Q)-rm $(BDIR)/list
	$(Q)-rm $(BDIR)/list.exclude

packagelists: ok apt-update genlist

# Build the raw list (cpp output) with doubles and spaces
$(BDIR)/rawlist:
# Dirty workaround for saving space, we add some hints to break ties.
# This is just a temporal solution, list2cds should be a little bit less
# silly so that this is not needed. For more info have a look at
# http://lists.debian.org/debian-cd/2004/debian-cd-200404/msg00093.html
	$(Q)if [ "$(SOURCEONLY)"x != "yes"x ] ; then \
		if [ "$(INSTALLER_CD)"x = "1"x ] ; then \
			echo >> $(BDIR)/rawlist; \
	    elif [ "$(INSTALLER_CD)"x = "2"x ] ; then \
			echo -e "mawk\nunifont\npptp-linux" >>$(BDIR)/rawlist; \
	    else \
		    echo -e "mawk\nexim4-daemon-light\nunifont\npptp-linux" >>$(BDIR)/rawlist; \
		fi; \
	fi

	$(Q)if [ "$(SOURCEONLY)"x != "yes"x ] ; then \
		if [ _$(INSTALLER_CD) != _1 ]; then \
			for ARCH in $(ARCHES_NOSRC); do \
				BINCLUDE=`[ -n "$(BASE_INCLUDE)" ] && cat $(BASE_INCLUDE) | tr "\n" "," | sed 's!,$$!!g'`; \
				[ -z "$$BINCLUDE" ] || BINCLUDE="--include=$$BINCLUDE"; \
				BEXCLUDE=`[ -n "$(BASE_EXCLUDE)" ] && cat $(BASE_EXCLUDE) | tr "\n" "," | sed 's!,$$!!g'`; \
				[ -z "$$BEXCLUDE" ] || BEXCLUDE="--exclude=$$BEXCLUDE"; \
				debootstrap --arch $$ARCH \
				            --print-debs \
				            $$BINCLUDE $$BEXCLUDE \
				            $(CODENAME) \
				            $(TDIR)/debootstrap.tmp \
				            file:$(MIRROR) \
			                $(DEBOOTSTRAP_SCRIPT) 2>/dev/null \
				    | tr ' ' '\n' > $(BDIR)/debootstrap-list; \
				cat $(BDIR)/debootstrap-list >>$(BDIR)/rawlist; \
				rm -rf $(TDIR)/debootstrap.tmp; \
			done; \
		fi; \
	fi

	$(Q)for ARCH in $(ARCHES_NOSRC); do \
		ARCHDEFS="$$ARCHDEFS -D ARCH_$(subst -,_,$$ARCH)"; \
		ARCHUNDEFS="$$ARCHUNDEFS -U $$ARCH"; \
	done; \
	if [ "$(SOURCEONLY)"x != "yes"x ] ; then \
		cat $(TASK) | \
		cpp -nostdinc -nostdinc++ -P -undef $$ARCHDEFS \
	   		$$ARCHUNDEFS -U i386 -U linux -U unix \
		    -DFORCENONUSONCD1=0 \
		    -I $(BASEDIR)/tasks -I $(BDIR) - - >> $(BDIR)/rawlist; \
	fi

    # If we're *only* doing source, then we need to build a list of all the
    # available source packages. Deliberately ignore the tasks too.
	$(Q)if [ "$(SOURCEONLY)"x = "yes"x ] ; then \
		awk '/^Package:/ {print $$2}' $(ADIR)/$(CODENAME)-source/apt-state/lists/*Sources | \
			sort -u > $(BDIR)/rawlist; \
	fi
#	ls -al $(BDIR)/rawlist

# Build the raw list (cpp output) with doubles and spaces for excluded packages
$(BDIR)/rawlist-exclude:
	$(Q)if [ -n "$(EXCLUDE)" ]; then \
		for ARCH in $(ARCHES); do \
			ARCHDEFS="$$ARCHDEFS -D ARCH_$(subst -,_,$$ARCH)"; \
			ARCHUNDEFS="$$ARCHUNDEFS -U $$ARCH"; \
		done; \
	 	perl -npe 's/\@ARCH\@/$(ARCH)/g' $(EXCLUDE) | \
			cpp -nostdinc -nostdinc++ -P -undef $$ARCHDEFS \
			$$ARCHUNDEFS -U i386 -U linux -U unix \
			-DFORCENONUSONCD1=0 \
			-I $(BASEDIR)/tasks -I $(BDIR) - - >> $(BDIR)/rawlist-exclude; \
	else \
		echo > $(BDIR)/rawlist-exclude; \
	fi

# Generate the complete listing of packages from the task
# Build a nice list without doubles and without spaces
genlist: ok $(BDIR)/list $(BDIR)/list.exclude
$(BDIR)/list: $(BDIR)/rawlist
	@echo "Generating the complete list of packages to be included in $(BDIR)/list..."
	$(Q)perl -ne 'chomp; next if /^\s*$$/; \
	          print "$$_\n" if not $$seen{$$_}; $$seen{$$_}++;' \
		  $(BDIR)/rawlist \
		  > $(BDIR)/list

$(BDIR)/list.exclude: $(BDIR)/rawlist-exclude
	@echo "Generating the complete list of packages to be removed ..."
	$(Q)perl -ne 'chomp; next if /^\s*$$/; \
	          print "$$_\n" if not $$seen{$$_}; $$seen{$$_}++;' \
		  $(BDIR)/rawlist-exclude \
		  > $(BDIR)/list.exclude

## IMAGE BUILDING ##

image-trees: ok genlist
    # Use list2cds to do the dependency sorting
	$(Q)for ARCH in $(ARCHES_NOSRC); do \
		ARCH=$$ARCH $(list2cds) $(BDIR)/list; \
	done
	$(Q)if [ "$(SOURCEONLY)"x = "yes"x ] ; then \
		$(grab_source_list) $(BDIR) $(ADIR) $(BDIR)/list $(BDIR)/packages; \
	else \
		$(merge_package_lists) $(BDIR) $(ADIR) "$(ARCHES)" $(BDIR)/packages; \
	fi
	$(Q)$(BASEDIR)/tools/make_disc_trees.pl $(BASEDIR) $(MIRROR) $(TDIR) $(CODENAME) "$(ARCHES)" $(MKISOFS)

# DOJIGDO actions   (for both binaries and source)
#    0    isofile
#    1    isofile + jigdo, cleanup_jigdo
#    2    jigdo, cleanup_jigdo
#
images: ok $(OUT) $(BDIR)/md5-check
	$(Q)$(make_image) "$(BDIR)" "$(ARCHES)" "$(OUT)" "$(DOJIGDO)" "$(DEBVERSION)" "$(MIRROR)" "$(MKISOFS)" "$(MKISOFS_OPTS)" "$(JIGDO_OPTS)" "$(jigdo_cleanup)"

check-number-given:
	@test -n "$(CD)" || (echo "Give me a CD=<num> parameter !" && false)

# Generate only one image number $(CD)
image: check-number-given images

# Calculate the md5sums for the images (if available), or get from templates
imagesums:
	$(Q)$(BASEDIR)/tools/imagesums $(OUT)

## MISC TARGETS ##

$(BDIR)/md5-check: mirrorcheck	

mirrorcheck: ok
	$(Q)$(grab_md5) $(MIRROR) "$(ARCHES)" $(CODENAME) $(DI_CODENAME) $(BDIR)/md5-check
	$(Q)for ARCH in $(ARCHES); do \
		if [ -e $(BASEDIR)/data/$(CODENAME)/$$ARCH/extra-sources ]; then \
			echo "Extra dedicated source added; need to grab source MD5 info too"; \
			$(grab_md5) $(MIRROR) source $(CODENAME) $(DI_CODENAME) $(BDIR)/md5-check; \
		fi; \
	done

update-popcon:

=== debian/changelog ===
debian-cd (3.0.4) unstable; urgency=low

  [ Frans Pop ]
  * Disable debugging output in boot scripts.

  [ Otavio Salvador ]
  * Applied patch from Robert Millan <rmh@aybabtu.com> to integrate
    win32-loader. Closes: #440220.
  * Applied patch from Robert Millan <rmh@aybabtu.com> to fix image
    generation with read-only mirrors. Closes: #441397.
  * Applied patch from Robert Millan <rmh@aybabtu.com> to use win32-loader
    for autorun when CD is being used on Windows. Closes: #441846.
  * Exclude dhcp-client-udeb since it's not being used and transition for
    dhcp3-client-udeb has over.
  * Exclude multipath-udeb and libaio1-udeb since they're not being use
    yet.
  * Fix autorun.inf generation when win32-loader is present.
  * Applied patch from Nicolas François <nicolas.francois@centraliens.net>
    to allow README.html translation using po4a.
  * Remove the 'Last Modified' date from data/lenny/README.html.in since
    it's useless.
  * Use DEBOOTSTRAP_SCRIPT, BASE_INCLUDE and BASE_EXCLUDE variables to
    calculate the base packages set
  * Hide image creation command if not using verbosing make

  [ Steve McIntyre ]
  * Make daily i386/amd64 lenny builds work again - don't attempt to copy
    the win32-loader files into place if they don't exist.
  * Remove Depends: on sysutils. Closes: #437497 (again)

  [ Jérémy Bobbio ]
  * README.html: Integrate a new look for README.html done by Kalle Söderman.
    Huge thanks to him!
  * README: Improve the wording when building a netinst or business card by
    being a little bit more specific than just saying: CD 1 out of 1.  This
    meant adding new defines "DISKTYPE$DISKTYPE".

  [ Joey Hess ]
  * Include dmraid deb. Closes: #443991
  * Add acpi-support-base to generate_di+k_list.

  [ Steve McIntyre ]
  * Newer versions of debootstrap have moved the scripts from /usr/lib to
    /usr/share. Add a sym-link to cope - let's keep compatible with etch
    as much as possible. Also, log what debootstrap told us (in
    debootstrap-list) rather than just including the results directly in
    rawlist.

  [ Frans Pop ]
  * build_all.sh: don't source CONF.sh after already sourcing $CF earlier.
  * CONF.sh: add non-invasive option to avoid sourcing CONF.sh twice when
    using wrapper scripts.
  * CONF.sh: Don't set MAXCDS by default; was probably changed by accident.
  * boot-{mipsel,sparc}: Parse website directory index case insensitive so
    that both "<a href=" and "<A HREF=" are recognized.
  * Include busybox for architectures that use initramfs-tools; base-installer
    will try to install it.
  * tools/update_tasks: ignore comments and blank lines in tasks/task.list.
  * tasks/task.list*
    - add missing l10n tasks: gujarati-desktop, malayalam-desktop, tamil
    - comment out l10n tasks for languages not supported in D-I, for
      Icelandic, Irish, Serbian, Welsh and Xhosa
  * lenny tasks: update for current task lists; set svn:keywords so the date
    header gets updated.
  * Instead of including all alternative dependencies in list2cds, only
    include the first one. This reduces the size of the netinst and improves
    what's included on CD1. Only loss is console-{data,common,tools} so these
    are now added in generate_di+k_list. Reduces impact of #410418.
  * exclude-udebs: exclude any libdirectfb udeb instead of particular version.
  * exclude-udebs: exclude kbd-udeb and console-setup udebs (not yet used).
  * During installation debootstrap will complain about an invalid Release file
    if there is no Packages file for the local section. Create an empty Packages
    file if one is missing.
  * start_new_disc: make multi-arch CD/DVDs and CD/DVDs that are not part of a
    set (e.g. KDE/Xfce CDs) recognizable through info in .disk directory.
  * Makefile: debootstrap no longer accepts options with empty values; change
    the way include/exclude options are passed accordingly.

  [ Steve McIntyre ]
  * Significant cleanup of list2cds. Closes: #451237
  * tools/imagesums: use newer features in latest mkisofs/genisoimage to grab
    pre-calculated MD5 and SHA1 checksums directly from the jigdo file.

  [ Otavio Salvador ]
  * Make sure we include laptop-detect on arches that are know to have
    laptops (i386, amd64 and powerpc).
  * Make sure we include grub-pc since it's used when GPT disk label is
    chosen.

  [ Steve McIntyre ]
  * Fix a bug in start_new_disc - cope with MAXCDS not being set.
  * Temporarily disable boot support for arm CDs - the netwinder images are not
    being produced at the moment.

  [ Raphael Hertzog ]
  * Switch to genisoimage as default ISO generator as mkisofs has been dropped
    from Debian. Closes: #468850
  * Add Vcs-Browser field.
  * If genisomage is not available, try to fallback on mkisofs.
  * New OMIT_DOC_TOOLS option to be able to work with mirrors that do not
    contain the doc and tools directories.

  [ Frans Pop ]
  * Ensure that the correct version of the Installation Guide is included.
  * Lenny will be version 5.0.

 -- Steve McIntyre <93sam@debian.org>  Mon, 17 Mar 2008 23:16:20 +0000

=== debian/control ===
Source: debian-cd
Section: admin
Priority: extra
Maintainer: Debian CD Group <debian-cd@lists.debian.org>
Uploaders: Raphael Hertzog <hertzog@debian.org>, Santiago Garcia Mantinan <manty@debian.org>, Steve McIntyre <93sam@debian.org>
Build-Depends: debhelper (>= 4)
Build-Depends-Indep: tofrodos
Standards-Version: 3.6.1.0
Vcs-Svn: svn://svn.debian.org/debian-cd/trunk
Vcs-Browser: http://svn.debian.org/wsvn/debian-cd/trunk?op=log

Package: debian-cd
Architecture: all
Depends: perl, cpp, libdigest-md5-perl, tofrodos, apt (>= 0.3.11.1), make, genisoimage, lynx, grep-dctrl, bc, libcompress-zlib-perl
Recommends: hfsutils, netpbm, syslinux
Description: Tools for building (Official) Debian CD set
 Debian-cd is the official tool for building Debian CD set since the potato
 release. It was formerly called YACS (for Yet Another CD Script).
 .
 Its goal is to facilitate the creation of customized Debian CD set.

## debian-cd 3.1.0

=== Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
 Q=@
 endif
 ifndef TASK
-TASK=$(BASEDIR)/tasks/Debian_$(CODENAME)
+TASK=Debian-generic
 endif
 ifndef MKISOFS
 export MKISOFS=$(shell which genisoimage mkisofs | head -1)
@@ -32,9 +32,6 @@
 ifndef HOOK
 HOOK=$(BASEDIR)/tools/$(CODENAME).hook
 endif
-ifndef DOJIGDO
-export DOJIGDO=0
-endif
 
 export BUILD_DATE=$(shell date -u +%Y%m%d-%H:%M)
 export ARCHES_NOSRC=$(shell echo $(ARCHES) | sed 's/source//')
@@ -47,7 +44,7 @@
 
 ## Internal variables  
 apt=$(BASEDIR)/tools/apt-selection
-list2cds=$(BASEDIR)/tools/list2cds
+sort_deps=$(BASEDIR)/tools/sort_deps
 md5sum=md5sum
 jigdo_cleanup=$(BASEDIR)/tools/jigdo_cleanup
 grab_md5=$(BASEDIR)/tools/grab_md5
@@ -56,15 +53,17 @@
 update_popcon=$(BASEDIR)/tools/update_popcon
 update_tasks=$(BASEDIR)/tools/update_tasks
 grab_source_list=$(BASEDIR)/tools/grab_source_list
+which_deb=$(BASEDIR)/tools/which_deb
 
 BDIR=$(TDIR)/$(CODENAME)
+TASKDIR=$(BDIR)/tasks
 ADIR=$(APTTMP)
 DB_DIR=$(BDIR)/debootstrap
 
 export DEBOOTSTRAP_DIR := $(DB_DIR)/usr/lib/debootstrap
 export PATH := $(DB_DIR)/usr/sbin:$(PATH)
-
-LATEST_DB := $(shell ls -1tr $(MIRROR)/pool/main/d/debootstrap/debootstrap*all.deb | tail -1)
+export BDIR
+export TASKDIR
 
 ## DEBUG STUFF ##
 
@@ -109,7 +108,7 @@
 ## INITIALIZATION ##
 
 # Creation of the directories needed
-init: ok $(OUT) $(TDIR) $(BDIR) $(ADIR) $(BDIR)/DATE $(DB_DIR) unstable-map
+init: ok $(OUT) $(TDIR) $(BDIR) $(ADIR) $(TASKDIR) $(BDIR)/DATE $(DB_DIR) unstable-map
 $(OUT):
 	$(Q)mkdir -p $(OUT)
 $(TDIR):
@@ -118,14 +117,31 @@
 	$(Q)mkdir -p $(BDIR)
 $(ADIR):
 	$(Q)mkdir -p $(ADIR)
+$(TASKDIR):
+	$(Q)echo "Updating task files..."
+	$(Q)mkdir -p $(TASKDIR)
+	$(Q)echo "- copying task files from 'tasks/$(DI_CODENAME)/'"
+	$(Q)cp -r $(BASEDIR)/tasks/$(CODENAME)/* $(TASKDIR)
+	$(Q)echo "- task.languages: using 'tasks/$(DI_CODENAME)/$(TASK_LANGLIST)'"
+	$(Q)cp $(BASEDIR)/tasks/$(DI_CODENAME)/$(TASK_LANGLIST) \
+		$(TASKDIR)/task.languages
+	$(Q)echo "- generating dynamic task files"
+	$(Q)set -e; cd $(TASKDIR); \
+		$(BASEDIR)/tools/update_tasks; \
+		$(BASEDIR)/tools/generate_di_list; \
+		$(BASEDIR)/tools/generate_di+k_list
 $(BDIR)/DATE:
 	$(Q)date '+%Y%m%d' > $(BDIR)/DATE
+
+ifdef MIRROR
+LATEST_DB := $(MIRROR)/$(shell $(which_deb) $(MIRROR) $(CODENAME) debootstrap)
 $(DB_DIR): $(LATEST_DB)
 	@rm -rf $(DB_DIR)
-	@dpkg -x $(LATEST_DB) $(DB_DIR)
-	if [ ! -e $(DEBOOTSTRAP_DIR) ] ; then \
+	$(Q)dpkg -x $(LATEST_DB) $(DB_DIR)
+	$(Q)if [ ! -e $(DEBOOTSTRAP_DIR) ] ; then \
 		ln -sf share $(DB_DIR)/usr/lib ; \
 	fi
+endif
 
 # Make sure unstable/sid points to testing/lenny, as there is no build
 # rule for unstable/sid.
@@ -145,6 +161,7 @@
 clean: ok dir-clean
 dir-clean:
 	$(Q)rm -rf $(BDIR)/CD[1234567890]*
+	$(Q)rm -rf $(TASKDIR)
 	$(Q)rm -f $(BDIR)/*.filelist*
 	$(Q)rm -f  $(BDIR)/packages-stamp $(BDIR)/upgrade-stamp $(BDIR)/md5-check
 
@@ -247,25 +264,23 @@
 # Deleting the list only
 deletelist: ok
 	$(Q)-rm $(BDIR)/rawlist
-	$(Q)-rm $(BDIR)/rawlist-exclude
 	$(Q)-rm $(BDIR)/list
-	$(Q)-rm $(BDIR)/list.exclude
 
 packagelists: ok apt-update genlist
 
 # Build the raw list (cpp output) with doubles and spaces
 $(BDIR)/rawlist:
 # Dirty workaround for saving space, we add some hints to break ties.
-# This is just a temporal solution, list2cds should be a little bit less
+# This is just a temporal solution, sort_deps should be a little bit less
 # silly so that this is not needed. For more info have a look at
 # http://lists.debian.org/debian-cd/2004/debian-cd-200404/msg00093.html
 	$(Q)if [ "$(SOURCEONLY)"x != "yes"x ] ; then \
 		if [ "$(INSTALLER_CD)"x = "1"x ] ; then \
-			echo >> $(BDIR)/rawlist; \
-	    elif [ "$(INSTALLER_CD)"x = "2"x ] ; then \
-			echo -e "mawk\nunifont\npptp-linux" >>$(BDIR)/rawlist; \
-	    else \
-		    echo -e "mawk\nexim4-daemon-light\nunifont\npptp-linux" >>$(BDIR)/rawlist; \
+			: ; \
+		elif [ "$(INSTALLER_CD)"x = "2"x ] ; then \
+			echo -e "mawk" >>$(BDIR)/rawlist; \
+		else \
+			echo -e "mawk\nexim4-daemon-light" >>$(BDIR)/rawlist; \
 		fi; \
 	fi
 
@@ -295,11 +310,11 @@
 		ARCHUNDEFS="$$ARCHUNDEFS -U $$ARCH"; \
 	done; \
 	if [ "$(SOURCEONLY)"x != "yes"x ] ; then \
-		cat $(TASK) | \
+		cat $(TASKDIR)/$(TASK) | \
 		cpp -nostdinc -nostdinc++ -P -undef $$ARCHDEFS \
 	   		$$ARCHUNDEFS -U i386 -U linux -U unix \
 		    -DFORCENONUSONCD1=0 \
-		    -I $(BASEDIR)/tasks -I $(BDIR) - - >> $(BDIR)/rawlist; \
+		    -I $(TASKDIR) - - >> $(BDIR)/rawlist; \
 	fi
 
     # If we're *only* doing source, then we need to build a list of all the
@@ -310,25 +325,9 @@
 	fi
 #	ls -al $(BDIR)/rawlist
 
-# Build the raw list (cpp output) with doubles and spaces for excluded packages
-$(BDIR)/rawlist-exclude:
-	$(Q)if [ -n "$(EXCLUDE)" ]; then \
-		for ARCH in $(ARCHES); do \
-			ARCHDEFS="$$ARCHDEFS -D ARCH_$(subst -,_,$$ARCH)"; \
-			ARCHUNDEFS="$$ARCHUNDEFS -U $$ARCH"; \
-		done; \
-	 	perl -npe 's/\@ARCH\@/$(ARCH)/g' $(EXCLUDE) | \
-			cpp -nostdinc -nostdinc++ -P -undef $$ARCHDEFS \
-			$$ARCHUNDEFS -U i386 -U linux -U unix \
-			-DFORCENONUSONCD1=0 \
-			-I $(BASEDIR)/tasks -I $(BDIR) - - >> $(BDIR)/rawlist-exclude; \
-	else \
-		echo > $(BDIR)/rawlist-exclude; \
-	fi
-
 # Generate the complete listing of packages from the task
 # Build a nice list without doubles and without spaces
-genlist: ok $(BDIR)/list $(BDIR)/list.exclude
+genlist: ok $(BDIR)/list
 $(BDIR)/list: $(BDIR)/rawlist
 	@echo "Generating the complete list of packages to be included in $(BDIR)/list..."
 	$(Q)perl -ne 'chomp; next if /^\s*$$/; \
@@ -336,34 +335,25 @@
 		  $(BDIR)/rawlist \
 		  > $(BDIR)/list
 
-$(BDIR)/list.exclude: $(BDIR)/rawlist-exclude
-	@echo "Generating the complete list of packages to be removed ..."
-	$(Q)perl -ne 'chomp; next if /^\s*$$/; \
-	          print "$$_\n" if not $$seen{$$_}; $$seen{$$_}++;' \
-		  $(BDIR)/rawlist-exclude \
-		  > $(BDIR)/list.exclude
-
 ## IMAGE BUILDING ##
 
 image-trees: ok genlist
-    # Use list2cds to do the dependency sorting
+    # Use sort_deps to do the dependency sorting
 	$(Q)for ARCH in $(ARCHES_NOSRC); do \
-		ARCH=$$ARCH $(list2cds) $(BDIR)/list; \
+		ARCH=$$ARCH $(sort_deps) $(BDIR)/list; \
 	done
 	$(Q)if [ "$(SOURCEONLY)"x = "yes"x ] ; then \
 		$(grab_source_list) $(BDIR) $(ADIR) $(BDIR)/list $(BDIR)/packages; \
 	else \
 		$(merge_package_lists) $(BDIR) $(ADIR) "$(ARCHES)" $(BDIR)/packages; \
 	fi
+	$(Q)if [ "$(INC_SOURCE)"x = "yes"x ] ; then \
+		grep ^source $(BDIR)/packages > $(BDIR)/packages.source; \
+	fi
 	$(Q)$(BASEDIR)/tools/make_disc_trees.pl $(BASEDIR) $(MIRROR) $(TDIR) $(CODENAME) "$(ARCHES)" $(MKISOFS)
 
-# DOJIGDO actions   (for both binaries and source)
-#    0    isofile
-#    1    isofile + jigdo, cleanup_jigdo
-#    2    jigdo, cleanup_jigdo
-#
 images: ok $(OUT) $(BDIR)/md5-check
-	$(Q)$(make_image) "$(BDIR)" "$(ARCHES)" "$(OUT)" "$(DOJIGDO)" "$(DEBVERSION)" "$(MIRROR)" "$(MKISOFS)" "$(MKISOFS_OPTS)" "$(JIGDO_OPTS)" "$(jigdo_cleanup)"
+	$(Q)$(make_image) "$(BDIR)" "$(ARCHES)" "$(OUT)" "$(DEBVERSION)" "$(MIRROR)" "$(MKISOFS)" "$(MKISOFS_OPTS)" "$(JIGDO_OPTS)" "$(jigdo_cleanup)"
 
 check-number-given:
 	@test -n "$(CD)" || (echo "Give me a CD=<num> parameter !" && false)
@@ -373,7 +363,7 @@
 
 # Calculate the md5sums for the images (if available), or get from templates
 imagesums:
-	$(Q)$(BASEDIR)/tools/imagesums $(OUT)
+	$(Q)$(BASEDIR)/tools/imagesums $(OUT) $(SUMS_EXTENSION)
 
 ## MISC TARGETS ##
 
@@ -389,3 +379,7 @@
 	done
 
 update-popcon:
+	$(update_popcon) tasks/$(CODENAME)/popularity-contest
+
+# Little trick to simplify things
+official_images: ok init packagelists image-trees images

=== debian/changelog ===
debian-cd (3.1.0) unstable; urgency=low

  [ Frans Pop ]
  * Don't include brltty on netinst images as it pulls in libicu which causes
    a 5MB size increase of the image, which is out of proportion given its use.
    This should not affect users as netinst installs should normally use a
    mirror and thus the package will be installed from there if needed.
    brltty will still get included on full CDs and DVDs through forcd1.
  * Remove references to no longer used files rawlist.exclude and list.exclude.
  * Clean up no longer needed compatibility code in lenny x86 boot script.

  [ Steve McIntyre ]
  * Rename list2cds to sort_deps.
  * Fix how directory trees are created in update-cd. Closes: #503911.
  * Update update_popcon to cope better with errors; now uses curl instead
    of wget.

  [ Raphael Hertzog ]
  * Don't try to copy sbm on etch CD images as it got removed.
  * Also extract isolinux.bin from the syslinux package in the case of etch
    CD images (since it's no more provided by debian-cd itself). 

  [ Frans Pop ]
  * Rework the way tasks are handled:
    - all tasks files are moved to ./tasks/<codename> subdirectories so they
      can be more easily kept up-to-date with specific distro releases
    - always generate the debian-installer and tasksel tasks dynamically:
      . all task files for the desired suite are copied to the working
        directory at the beginning of each build, and are used from there
      . the debian-installer and tasksel tasks are no longer included in
        releases but are always created automatically at build time; this
        means users no longer need to run the generate_di_* scripts or the
        update_tasksel script
      . the popcon task file will remain included as a static file, but plan
        is to add an option to update it automatically for each build; reason
        is that updating it requires network access
    - bump version to 3.1
  * Update the contrib/testingcds script based on its current version on
    farbror.
  * Clean up and update interesting-fromcd23 and exclude task files for lenny.
  * Fix error in expansion of %ARCH% variables in D-I image location envvars.
  * Fix i386/amd64 multi-arch support in the lenny x86 boot script so that the
    isolinux config gets modified correctly independent of the order in which
    the arches are specified.
  * Workaround #505243 by modifying the syslinux configuration for amd64/i386
    multi-arch images and using ifcpu64.c32 to autodetect 32/64-bit systems
    when a user hits enter from the isolinux help screens. Based on research
    done by Franklin Piat.

  [ Steve McIntyre ]
  * Stop copying the /tools/ directory on from the mirror; it's going away.
  * Add support for multiple desktop tasks on a single disk
  * Add support for tracking which packages we've extracted binaries from,
    so that we can archive them (both binaries and sources). If we need
    anything, we will list it in CD$N.pkgs_extracted so that external
    scripts can pick it up and do whatever's needed.
  * Minor changes to the interface of tools/which_deb to accommodate that:
    now just lists the files *within* the mirror; it's up to callers to
    prepend ${MIRROR} as needed.

  [ Frans Pop ]
  * make_image: ensure correct quoting of variables when calling genisoimage.
    Closes: #507300.
  * boot-hppa: support KERNEL_PARAMS (so desktop= can be passed).
  * boot-hppa: stop passing redundant boot parameters root and ramdisk_size.
  * Split out languages supported by D-I and tasksel from task.list files.
    Instead of duplicating what language tasks should be included in each
    task.list.* file, let update_tasks add them dynamically at runtime from a
    single list of languages supported by tasksel and D-I. This also makes
    maintaining the lists a lot less painful. Closes: #506616.
  * Indicate which tasks are "secondary" by adding a "-" suffix in task.list.*
    files instead of hardcoding it in update_tasks. Closes: #506668.
  * Add new file tasks/README.tasksel to document the way tasksel tasks are
    used when determining the order in which packages are added to images.
  * Update list of languages supported by tasksel and D-I for Lenny.
  * Add support for a separate 'LXDE desktop environment' CD.
  * Add support for a 'light desktop environment' CD (LXDE + Xfce).
    Includes a framework to manipulate the isolinux configuration for x86 so
    that a user can select which desktop he wishes to install.
  * Add support to create an 'all desktops' DVD.
    This new task will include all four desktop environments supported by
    tasksel (GNOME, KDE, LXDE and Xfce). On x86 it will also add an option in
    the isolinux menu (under Advanced options) to select which DE to install,
    but GNOME will remain default.
  * Add support for a separate 'GNOME desktop environment' CD.
    This new task is mostly added for completeness. Main difference with the
    default task file is that no server tasks are included.
  * Add a suffix "generic" to the default task files to make the overall naming
    scheme more consistent. It also allows to make update_tasks more generic.
  * Update exclude list for Lenny:
    - remove aspell* packages as they do not included on CD1 anyway and
      excluding them also means they get excluded from DVD1;
    - remove xen/vserver linux-image packages as they do not get included on
      CD1 anyway;
    - xmail and cdebconf were added as they got pulled in through alternative
      dependencies, which is no longer an issue.
  * Give priority to Key packages over regular packages for secondary tasks
    (similar to what we already did for primary tasks).
  * README.easy-build: document how to use custom packages and D-I images.
  * Add myself as uploader.

 -- Frans Pop <fjp@debian.org>  Mon, 12 Jan 2009 16:07:35 +0100

debian-cd (3.0.5) unstable; urgency=low

  [ Steve McIntyre ]
  * Pre-cache apt's package information in large lumps rather than walk


## debian-cd 3.1.1

=== Makefile ===
--- 
+++ 
@@ -118,6 +118,7 @@
 $(ADIR):
 	$(Q)mkdir -p $(ADIR)
 $(TASKDIR):
+ifneq ($(ARCHES),source)
 	$(Q)echo "Updating task files..."
 	$(Q)mkdir -p $(TASKDIR)
 	$(Q)echo "- copying task files from 'tasks/$(DI_CODENAME)/'"
@@ -130,6 +131,7 @@
 		$(BASEDIR)/tools/update_tasks; \
 		$(BASEDIR)/tools/generate_di_list; \
 		$(BASEDIR)/tools/generate_di+k_list
+endif
 $(BDIR)/DATE:
 	$(Q)date '+%Y%m%d' > $(BDIR)/DATE

=== debian/changelog ===
debian-cd (3.1.1) unstable; urgency=high

  [ Frans Pop ]
  * sparc: remove bogus default "append=cdrom" line from silo.conf template.
  * sparc: ensure the default 'install' option also gets KERNEL_PARAMS set.
  * start_new_disc: fix a typo so that DISC_PKG_HOOK might work. Thanks to
    Jonathan Hall for the patch. Closes: #513421
  * boot-x86: drop support for no longer really useful ISOLINUX_DEFAULT
    environment variable (see #512303 for discussion).
  * x86: clean up compatibility code that was needed for D-I Lenny RC1
    isolinux configuration files.

  [ Otavio Salvador ]
  * do not exclude libaio1-udeb from CDs.

  [ Steve McIntyre ]
  * Merge patches from Jonathan Hall:
    + Add better support for extra components, improve non-i386 mirror
      support (Closes: 514237)
    + tools/update_tasks no longer assumes i386 for all builds (Closes: #513497)
    + tools/which_deb no longer assumes i386 for all builds (Closes: #513498)
  * For source-only builds, don't do any task updates as they're not
    useful anyway.
  * Last high-urgency upload, ready for Lenny!

 -- Steve McIntyre <93sam@debian.org>  Thu, 12 Feb 2009 09:13:24 +0000

=== debian/control ===
Source: debian-cd
Section: admin
Priority: extra
Maintainer: Debian CD Group <debian-cd@lists.debian.org>
Uploaders: Raphael Hertzog <hertzog@debian.org>, Santiago Garcia Mantinan <manty@debian.org>, Steve McIntyre <93sam@debian.org>, Frans Pop <fjp@debian.org>
Build-Depends: debhelper (>= 5)
Build-Depends-Indep: tofrodos
Standards-Version: 3.6.1.0
Vcs-Svn: svn://svn.debian.org/debian-cd/trunk
Vcs-Browser: http://svn.debian.org/wsvn/debian-cd/trunk?op=log

Package: debian-cd
Architecture: all
Depends: curl, perl, cpp, libdigest-md5-perl, tofrodos, apt (>= 0.3.11.1), make, genisoimage, lynx-cur | lynx, grep-dctrl, bc, libcompress-zlib-perl
Recommends: hfsutils, netpbm, syslinux-common
Description: Tools for building (Official) Debian CD set
 Debian-cd is the official tool for building Debian CD set since the potato
 release. It was formerly called YACS (for Yet Another CD Script).
 .
 Its goal is to facilitate the creation of customized Debian CD set.

=== debian/rules ===
#!/usr/bin/make -f
#-*- makefile -*-
# Made with the aid of dh_make, by Craig Small
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.
# Some lines taken from debmake, by Christoph Lameter.

build: build-stamp
build-stamp:
	dh_testdir
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp install-stamp
	dh_clean

install: install-stamp
install-stamp: build-stamp
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the package into debian/tmp.
	cp -r contrib tools tasks data Makefile README README.devel build.sh \
              build_all.sh update-cd easy-build.sh README.easy-build \
              debian/debian-cd/usr/share/debian-cd/
	cp debian/CONF.sh debian/debian-cd/etc/debian-cd/conf.sh
	ln -sf /etc/debian-cd/conf.sh \
               debian/debian-cd/usr/share/debian-cd/CONF.sh
	find debian/debian-cd -name '.svn' | xargs -r rm -rf
	find debian/debian-cd/usr/share/debian-cd/tools/boot \
	  \( -name 'boot-*' -o -name 'post-boot-*' \) -a \! -name '*.txt' \
	  -a \! -name '*.calc' |  xargs chmod 0755

	touch install-stamp

# Build architecture-dependent files here.
binary-arch: build install
# We have nothing to do by default.

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir
	dh_testroot
	dh_installdocs README*
	dh_installexamples
	dh_installmenu
	dh_installcron
	dh_installman
	dh_installchangelogs
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary

## debian-cd 3.1.2

=== Makefile ===
--- 
+++ 
@@ -145,14 +145,14 @@
 	fi
 endif
 
-# Make sure unstable/sid points to testing/lenny, as there is no build
+# Make sure unstable/sid points to testing/squeeze, as there is no build
 # rule for unstable/sid.
 unstable-map:
 	$(Q)if [ ! -d $(BASEDIR)/data/sid ] ; then \
-		ln -s lenny $(BASEDIR)/data/sid ; \
+		ln -s squeeze $(BASEDIR)/data/sid ; \
 	fi
 	$(Q)if [ ! -d $(BASEDIR)/tools/boot/sid ] ; then \
-		ln -s lenny $(BASEDIR)/tools/boot/sid ; \
+		ln -s squeeze $(BASEDIR)/tools/boot/sid ; \
 	fi
 
 #################

=== debian/changelog ===
debian-cd (3.1.2) unstable; urgency=low

  [ Frans Pop ]
  * Add support for squeeze.

  [ Colin Watson ]
  * Luk Claes has taken over alpha, amd64, mips, and mipsel daily d-i
    builds.

  [ Steve McIntyre ]
  * Don't call images beta if they're using OFFICIAL_VAL == 2.
    Closes: #516353
  * Add wpasupplicant to tasks/*/forcd1 . Closes: #517298. It's a small
    package that should fit easily.
  * tools/sort_deps: Sort dependencies better: if A dep B then we should
    NOT list A before B. Closes: #518145.

  [ Joey Hess ]
  * Add firmware-linux to firmware task.
  * Re-add zd1211-firmware to firmware task.

  [ Steve McIntyre ]
  * tools/imagesums: Add support for more checksum types. genisoimage
    will shortly start generating sha256 and sha512 sums too.
  * Recognise and ignore Breaks: lines. Closes: #523444
  * Re-add code to generate install.bat on x86 machines. Thanks to Samuel
    Thibault for the patch. Closes: #518807
  * Modify README.html: only attempt to link to the release notes and
    installation manual on release-ready builds, otherwise suggest the
    alioth version of the installation manual. Closes: #330398

 -- Steve McIntyre <93sam@debian.org>  Sat, 16 May 2009 22:12:32 +0100

## debian-cd 3.1.3

=== Makefile ===
--- 
+++ 
@@ -190,7 +190,7 @@
 $(ADIR)/status:
 	@echo "Generating a fake status file for apt-get and apt-cache..."
 	$(Q)for ARCH in $(ARCHES); do \
-		mkdir -p $(ADIR)/$(CODENAME)-$$ARCH; \
+		mkdir -p $(ADIR)/$(CODENAME)-$$ARCH/apt/preferences.d; \
 		if [ $$ARCH = "source" -o "$(INSTALLER_CD)" = "1" -o "$(INSTALLER_CD)" = "2" ];then \
 			:> $(ADIR)/$(CODENAME)-$$ARCH/status ; \
 		else \
@@ -311,9 +311,12 @@
 		ARCHDEFS="$$ARCHDEFS -D ARCH_$(subst -,_,$$ARCH)"; \
 		ARCHUNDEFS="$$ARCHUNDEFS -U $$ARCH"; \
 	done; \
+	for VARIANT in $(VARIANTS); do \
+		VARIANTDEFS="$$VARIANTDEFS -D VARIANT_$$VARIANT"; \
+	done; \
 	if [ "$(SOURCEONLY)"x != "yes"x ] ; then \
 		cat $(TASKDIR)/$(TASK) | \
-		cpp -nostdinc -nostdinc++ -P -undef $$ARCHDEFS \
+		cpp -nostdinc -nostdinc++ -P -undef $$ARCHDEFS $$VARIANTDEFS\
 	   		$$ARCHUNDEFS -U i386 -U linux -U unix \
 		    -DFORCENONUSONCD1=0 \
 		    -I $(TASKDIR) - - >> $(BDIR)/rawlist; \

=== debian/changelog ===
debian-cd (3.1.3) unstable; urgency=low

  [ Frans Pop ]
  * Adjust x86 boot scripts for new version (2.0) of framework in D-I for
    creation of syslinux configuration files. Essentially the new version
    is a backport of what was already implemented in debian-cd before the
    release of Lenny and allows a significant simplification.
    There are no significant changes in generated CD/DVD images.
  * Split out code for workaround for #505243 to x86-desktop function library.
  * sparc: display message for unsupported subarchitectures.
  * Only do boot disk stuff for x86 and alpha if the image is supposed to be
    bootable. Avoids downloading x86 D-I images for all 30+ CDs in a full set.
  * Don't download floppy D-I images for i386; they're no longer available.
  * Don't fetch D-I images for the prep subarchitecture; it is not available.
  * Add path when sourcing CONF.sh for compatibility with dash. Spotted by
    Ian Campbell.
  * Add console-setup to packages needed for D-I.

  [ Steve McIntyre ]
  * Remove bashism in tools/apt-selection. Closes: #530972

  [ Ian Campbell ]
  * Add support for "variants". A variant allows to include/exclude additional
    packages or D-I components relative to a regular image.
  * Add variant to create i386/amd64 images that support installing Xen guests.
  * Recognise and ignore Enhances: lines.
  * Create apt/preferences.d in APTTMP, keeps newer apt from printing a warning.

  [ Raphaël Hertzog ]
  * Fallback looking for syslinux/silo/yaboot in $CODENAME when $DI_CODENAME
    didn't gave any result. This is useful when using partial mirrors built by
    simple-cdd while trying to build a Debian CD using a newer d-i (in my case
    etch CD with lenny d-i).
  * Use dpkg --fsys-tarfile instead of ar for extracting files from deb
    packages. The previous invocation could have failed for packages using
    something other than gzip compression.
  * Fix syntax errors in tools/boot/{lenny,squeeze}/boot-m68k (thanks to
    lintian).

  [ Steve McIntyre ]
  * Fix link in README.html.in for lenny, and update squeeze to match.
    Closes: #542191

  [ Frans Pop ]
  * s390: Add boot files specifying offset and size of the initrd for booting
    from CD. Change is based on SuSE's CD boot. Many thanks to Adam Thornton,
    Mark Post and Bastian Blank for providing the pointers to the missing bits.

  [ Steve McIntyre ]
  * Add support for coping with binary and source packages that are too
    large to fit. If we have to remove packages and their dependencies,
    list them in README.excluded in the root of disc 1.

  [ Joey Hess ]
  * Add firmware-linux-nonfree to firmware list. Left firmware-linux for now
    though it is now only a dependency package.
  * Add firmware-linux-free to firmware list, as a convenient way to make
    it available along with the other firmware files. (It could, instead,
    be included directly in d-i images, if there were a udeb.)
    Closes: 566561

  [ Karl Goetz ]
  * Improve the description for MAXCDS in the conf file. (Closes: #570028)
  * Export the CDNAME variable in the conf file. (Closes: #570470)

  [ Steve McIntyre ]
  * Cope with errors reported from debootstrap better; don't just treat
    the text output as package names. Closes: #570474

 -- Steve McIntyre <93sam@debian.org>  Sun, 21 Feb 2010 22:47:38 +0100
